#ifndef CONTAINER_H
#define CONTAINER_H

namespace container {

// The base class for any object that needs to be placed in the container.
struct Object {
  virtual ~Object() {};
};

// The key class for putting the object into a set.
struct Key {
  virtual int CompareTo(Key *aOther) = 0;

  virtual ~Key() {};
};

class Iterator {
public:
  virtual void First() = 0;
  virtual void Next() = 0;
  virtual Object* GetCurrentItem() = 0;
  virtual bool IsDone() = 0;

  virtual ~Iterator() {};
};

class Container {
public:
  virtual Iterator *GetIterator() = 0;

  virtual ~Container() {};
};

} // namespace container

#endif
