#include "List.h"

// Work around compilers not supporting C++11
#define nullptr 0

namespace container {

void ListIterator::First()
{
  mCurrent = mContainer->mHead;
}

void ListIterator::Next()
{
  mCurrent = mCurrent->mNext;
}

Object* ListIterator::GetCurrentItem()
{
  return mCurrent->mItem;
}

bool ListIterator::IsDone()
{
  return mCurrent == nullptr;
}

ListIterator::ListIterator(List *aContainer)
  : mContainer(aContainer)
  , mCurrent(mContainer->mHead)
{
}

ListIterator::~ListIterator()
{
}

Iterator* List::GetIterator()
{
  // Note that the user needs to delete the iterator manually.
  // Use of std::auto_ptr is recommended.
  return new ListIterator(this);
}

void List::Append(Object *aObject)
{
  // TODO implement me.
}

void List::Remove(Object *aObject)
{
  // TODO implement me.
}

List::List()
  :mHead(nullptr)
{
}

} // container

