#include <iostream>

#include "TreeSet.h"

using namespace container;

class UserProfile: public Object {
public:
  UserProfile() : mName("Dummy"), mUserId("0000") {}
  UserProfile(char *aName, char *aUserId)
    :mName(aName), mUserId(aUserId) {}

  virtual ~UserProfile() {}

  char *GetName() { return mName; }
  char *GetUserId() { return mUserId; }
private:
  char *mName;
  char *mUserId;
};

void Iterate(Container *aContainer)
{
  Iterator *iter = aContainer->GetIterator();
  for(iter->First(); !iter->IsDone(); iter->Next()) {
    UserProfile *prof = dynamic_cast<UserProfile*>(iter->GetCurrentItem());

    std::cout << "Name: " << prof->GetName() << "\n";
  }

}

template <typename T, int N>
int ArrayLength(T (&arr)[N])
{
  return N;
}

int main(int argc, char **argv)
{
  TreeSet *profiles = new TreeSet();

  UserProfile userProfiles[] = {
      UserProfile("John Smith", "0001"),
      UserProfile("Jason Overhold", "0002")
  };

  for (int i = 0; i < ArrayLength(userProfiles); i++) {
    profiles->Insert(&TreeSetKey(userProfiles[i].GetUserId()), &userProfiles[i]);
  }

  Iterate(profiles);

  return 0;
}
