#ifndef CLOUDVAULT_H
#define CLOUDVAULT_H

#include "Cloud.h"

namespace cloud{
namespace vault {

class EncryptedFileSystem: public FileSystem
{
public:
  virtual void Connect(const char *aHost, uint16_t aPort) override;
  virtual void Disconnect() override;
  virtual bool IsConnected() override;

private:
  FileSystem *mImpl;
};

class EncryptedFile: public File
{
public:
  virtual const char * GetName() override;
  virtual void Delete() override;

private:
  File *mImpl;
  void DecryptBytes(const char *aEncryptedBytes,
                    char *aOutput,
                    size_t *aOutputLength);
};

class EncryptedFolder: public Folder
{
public:
  virtual void Delete();

private:
  Folder *mImpl;
};

}
}

#endif
