#ifndef DBOXCLIENT_H
#define DBOXCLIENT_H

#include "Cloud.h"
#include "vendor/DBoxClientImpl.h"

using cloud::FileSystem;
using cloud::File;
using cloud::Folder;

namespace cloud {
namespace dbox {

class DBoxFileSystem:
    public FileSystem,
    private impl::DBoxFileSystemClient // Use private inheritance to hide the impl.
{
public:
  virtual void Connect(const char *aHost, uint16_t aPort);
  virtual bool IsConnected();
  virtual void Disconnect();

  virtual ~DBoxFileSystem();
};

class DBoxFile:
    public File,
    private impl::DBoxFileImpl // Use private inheritance to hide the impl.
{
public:
  virtual const char * GetName() const;
  virtual void Delete() ;

  virtual ~DBoxFile() ;

};

class DBoxFolder:
    public Folder,
    private impl::DBoxFolderImpl // Use private inheritance to hide the impl.
{
public:
  virtual void Delete() ;

  virtual ~DBoxFolder() ;
};

}
}

#endif
