#include "GDriveClient.h"

namespace cloud {
namespace gdrive {

void
GDriveFileSystem::Connect(const char* aHost, uint16_t aPort)
{
  // Forward the invocation to vendor implementation.
  mImpl->connect(aHost, aPort);
}

bool
GDriveFileSystem::IsConnected()
{
  // Forward the invocation to vendor implementation.
  return mImpl->is_connected();
}

void
GDriveFileSystem::Disconnect()
{
  // Forward the invocation to vendor implementation.
  // Note that the option to work offline is lost in adaptation.
  mImpl->disconnect(false);
}

GDriveFileSystem::~GDriveFileSystem()
{
  delete mImpl;
  mImpl = NULL;
}

const char*
GDriveFile::GetName() const
{
  // Forward the invocation to vendor implementation.
  return mImpl->get_name();
}

void
GDriveFile::Delete()
{
  // Forward the invocation to vendor implementation.
  // Note that the option to archive is lost in adaptation.
  mImpl->delete_(false);
}

GDriveFile::~GDriveFile()
{
  delete mImpl;
  mImpl = NULL;
}

void GDriveFolder::Delete()
{
  // Forward the invocation to vendor implementation.
  // Note that the option to archive is lost in adaptation.
  mImpl->delete_(false);
}

GDriveFolder::~GDriveFolder()
{
  delete mImpl;
  mImpl = NULL;
}

} // namespace gdrive
} // namespace cloud
